<template>
    <div>
        <pageTopBar></pageTopBar>
        <seachModule :count="dataList.count" :getDataList="setSeachSelectData"></seachModule>
        <div class="dis-f jus-x al-item">
            <div class="body-maxWidth mg-t-35">
                <div class="dis-f jus-bet" v-show="dataList.data && dataList.data.length > 0">
                    <div ref="list">
                        <biserialItem v-for="(item, i) in pageList['1']" :key="i" :item="item" :imgLoad="watchImgLoad"
                            listId="1"></biserialItem>
                    </div>
                    <div>
                        <biserialItem v-for="(item, i) in pageList['2']" :key="i" :item="item" :imgLoad="watchImgLoad"
                            listId="2"></biserialItem>
                    </div>
                </div>
                <div class="dis-f jus-x no-list-box al-item" v-show="dataList.data && dataList.data.length === 0">
                    <noList></noList>
                </div>
            </div>
        </div>
        <loadMoreText :loadText="loading?'加载中....':'到底了'"></loadMoreText>
        <listBtmPrompt></listBtmPrompt>
        <footerTool></footerTool>
    </div>

    <!-- 右下角咨询 -->
    <circle-btn></circle-btn>
</template>
  
<script setup>
import { reactive, onMounted, ref, provide, onBeforeUnmount, nextTick } from 'vue'
import pageTopBar from '../../components/pageTopBar/pageTopBar.vue';
import seachModule from "../../components/seachModule/seachModule.vue";
import biserialItem from '../../components/biserialListItem/biserialListItem.vue'
import listBtmPrompt from "../../components/public/have-questions.vue";
import noList from "../../components/public/empty-duck.vue";
import circleBtn from '@/components/public/circle-btn.vue'
import api from "../../utils/api";
import tool from '../../toolJs/downLoadMore'
import { ElMessage } from 'element-plus'
import footerTool from '@/components/footer/footer.vue'
import loadMoreText from '../../components/loadMore/loadMoreText.vue'

//获取数据
let pages = ref(1)
let dataList = reactive({ data: [], count: 0 })
let dataCount = ref(0)
let pageList = reactive({ 1: [], 2: [], height1: 0, height2: 0, tab: 1 })
let seachSelectData = reactive({ data: {} })
let loading = ref(true)
provide('count', dataCount)

//保存搜索设置
let setSeachSelectData = (data) => {
    pages.value = 1
    seachSelectData.data = {
        ...data
    }
    loading.value = true
    getDataList(seachSelectData.data)
}

//初始化列表参数
let setInitial = () => {
    pageList[1] = []
    pageList[2] = []
    pageList.height1 = 0
    pageList.height2 = 0
}

//获取搜索数据
let getDataList = (data) => {
    if(!loading.value)return
    loading.value = false
    let postData = {
        page: pages.value,
        intermediary: 0,
        limit:20,
        ...data
    }
    api.getLists(postData).then(res => {
        if (res.code === 200) {
            dataList.data = res.data.data
            if (pages.value === 1) {
                setInitial()
            }
            pageList.tab = 1
            dataList.count = res.data.count
            dataCount.value = res.data.count
            nextTick(() => {
                if(dataList.data[0])pageList['1'].push(dataList.data[0])
                if(dataList.data[1])pageList['2'].push(dataList.data[1])
            })
        } else {
            ElMessage({
                message: res.message,
                center: true,
            })
        }
    })
}

//添加数据
let addListData = () => {
    let num = null
    if (pageList.tab > (dataList.count>20?dataList.data.length-2:dataList.count-2)) {
        console.log(dataList.data.length,20,loading.value)
        if(dataList.data.length>20){
            loading.value = true
        }else{
            loading.value = false
        }
        return
    }
    pageList.tab++
    if (pageList.height1 > pageList.height2) {
        num = 2
    } else {
        num = 1
    }
    pageList[num].push(dataList.data[pageList.tab])
}

//监听图片加载
let watchImgLoad = (id, listId, height) => {
    pageList[`height${listId}`] += height
    addListData()
}

//加载更多
let downLoadMore = () => {
    tool.loadMore(() => {
        if (!loading.value) return
        pages.value++
        getDataList(seachSelectData.data)
    })
}

//listImg
onMounted(() => {
    getDataList()
    window.addEventListener('scroll', downLoadMore, true);
})

onBeforeUnmount(() => {
    window.removeEventListener('scroll', downLoadMore, true);
})

</script>
<style scoped>
img {
    object-fit: contain;
}

.dis-f {
    display: flex;
}

.jus-x {
    justify-content: center;
}

.al-item {
    align-items: center;
}

.pos-r {
    position: relative;
}

.body-maxWidth {
    width: 1200px;
    min-width: 1200px;
}

.s-w-100 {
    width: 100%;
}

.jus-bet {
    justify-content: space-between;
}

.mg-t-35 {
    margin-top: 35px;
}

.no-list-box {
    height: 500px;
    background: inherit;
    background-color: rgba(255, 255, 255, 1);
    border: none;
    border-radius: 16px;
    -moz-box-shadow: 0px 0px 8px rgba(0, 0, 0, 0.0784313725490196);
    -webkit-box-shadow: 0px 0px 8px rgba(0, 0, 0, 0.0784313725490196);
    box-shadow: 0px 0px 8px rgba(0, 0, 0, 0.0784313725490196);
}
</style>
  